// search_configs.h:
// defines specific heuristic configuration for iterated local search


#if !defined(__HotFrame_SEARCH_CONFIG__)
#define __HotFrame_SEARCH_CONFIG__


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
namespace HotFrame
{


template <class C>
struct CSteepestDescent
{
  typedef BestPositiveNeighbor<C> NeighborSelection;

  typedef typename C::T T;
  typedef typename C::Range Range;
  typedef typename C::CNumeric CNumeric;
  typedef typename C::S S;
  typedef typename C::N N;

  typedef C Cp;
};


template <class C>
struct CSteepestDescentMildestAscent
{
  typedef BestNeighbor<C> NeighborSelection;

  typedef typename C::T T;
  typedef typename C::Range Range;
  typedef typename C::CNumeric CNumeric;
  typedef typename C::S S;
  typedef typename C::N N;

  typedef C Cp;
};


template <class C>
struct CFirstDescent
{
  typedef FirstPositiveNeighbor<C> NeighborSelection;

  typedef typename C::T T;
  typedef typename C::Range Range;
  typedef typename C::CNumeric CNumeric;
  typedef typename C::S S;
  typedef typename C::N N;

  typedef C Cp;
};


template <class C>
struct CRandomWalk
{
  typedef RandomNeighbor<C> NeighborSelection;

  typedef typename C::T T;
  typedef typename C::Range Range;
  typedef typename C::CNumeric CNumeric;
  typedef typename C::S S;
  typedef typename C::N N;

  typedef C Cp;
};


}
//--- end of namespace HotFrame -----------------------------------------------
//------------------------------------------------------------------------------


#endif
