// sa_configs.h:
// defines specific heuristic configuration for tabu search


#if !defined(__HotFrame_TABU_CONFIG__)
#define __HotFrame_TABU_CONFIG__

#include "tabu.h"


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

namespace HotFrame
{

//----------------------------------------------------------------------------
//-------------- Configuration of Tabu Search  -------------------------------
//----------------------------------------------------------------------------

template <class C>
class CTabuSearchByTabuization
{ 
  public:

    typedef typename C::CNumeric CNumeric;
    typedef typename C::Range Range;
    typedef typename C::T T;

    typedef typename C::S S;
    typedef typename C::N N;
    typedef typename C::S_A S_A;
    typedef typename C::S_I S_I;
	
    typedef C Cp;

    // typedef NoAspirationCriterion<C> ...
    typedef NewBestSolutionAspirationCriterion<C>
            AspirationCriterion;
    typedef BestAdmissibleNeighbor< CTabuSearchByTabuization<C> >
            TabuNeighborSelection;

    static double penaltyFactor;
};

template <class C>
double CTabuSearchByTabuization<C>::penaltyFactor = 0;



template <class C>
class CTabuSearchByPenalties
{ 
  public:

    typedef typename C::CNumeric CNumeric;
    typedef typename C::Range Range;
    typedef typename C::T T;

    typedef typename C::S S;
    typedef typename C::N N;
    typedef typename C::S_A S_A;
    typedef typename C::S_I S_I;
	
    typedef C Cp;
    typedef CTabuSearchByTabuization<C> Configuration;

    
    typedef NoAspirationCriterion<C> AspirationCriterion;
    typedef BestNeighborConsideringPenalties<Configuration> TabuNeighborSelection;

    static double penaltyFactor;
};


template <class C>
double CTabuSearchByPenalties<C>::penaltyFactor = 3.14;  // somehow arbitrary ...



}
//----end of namespace HotFrame---------------------------------------
//--------------------------------------------------------------------

#endif
